SystemOrganization addCategory: #'PVpub-AnalogClockPrototype05'!

PolygonMorph subclass: #ResizableWatchHand05
	instanceVariableNames: 'watchHand04m watchHand04 midnightVertices dial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!ResizableWatchHand05 class methodsFor: 'instance creation' stamp: 'pv 12/3/2013 21:00'!
newFrom: aDial 
	| watchHand05 |
	watchHand05 := self new.
	watchHand05 setDial: aDial.
	^ watchHand05! !

!ResizableWatchHand05 methodsFor: 'accessing' stamp: 'pv 12/4/2013 22:58'!
getMovingWatchhand
	^watchHand04! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:52'!
initialize
	super initialize.
	watchHand04m := WatchHand05 new.
	watchHand04 := WatchHand05 new.
	watchHand04 setMidnightWatchhand: watchHand04m! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
pvtAddMidnightWatchhandFrom: anArray 
	watchHand04m setMidnightVerticesFrom: anArray.
	watchHand04m setVertices: anArray;
		 visible: false.
	dial
		addMorph: watchHand04m
		fullFrame: (LayoutConcentricFrame
				left: 0.3
				right: 0.3
				top: 0.9
				bottom: 0.3)! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
pvtAddRotatingWatchhand
	watchHand04
		setInitialMidnightVerticesFromCenter: dial center
		andRadius: dial extent x / 2
		withFraction: 0.9.
	dial addMorph: watchHand04! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:30'!
setDial: aDial 
	dial := aDial! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter a |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	a := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self pvtAddMidnightWatchhandFrom: a.
	self pvtAddRotatingWatchhand! !

PolygonMorph subclass: #WatchHand05
	instanceVariableNames: 'midnightWatchhand midnightVertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!WatchHand05 class methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:19'!
inDegrees: aTime 
	"080413 should be a class method."
	| timeValue delta |
	delta := 0.0.
	timeValue := (aTime perform: #seconds) asFloat.
	^ 360 * timeValue / 60! !

!WatchHand05 methodsFor: 'accessing - properties' stamp: 'pv 12/2/2013 20:16'!
isMovingWatchhand
	self layoutFrame
		ifNil: [^ true].
	^ false! !

!WatchHand05 methodsFor: 'geometry' stamp: 'pv 12/5/2013 20:29'!
rotationDegreesFromMidnightPosition
	^ self rotationDegrees! !

!WatchHand05 methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:15'!
rotationDegreesFromMidnightPosition: degrees 
	| flex center |
	(center := self valueOfProperty: #referencePosition)
		ifNil: [self setProperty: #referencePosition toValue: (center := self bounds center)].
	flex := (MorphicTransform offset: center negated)
				withAngle: degrees degreesToRadians.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	self forwardDirection: degrees! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	midnightVertices := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self setVertices: midnightVertices! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightVerticesFrom: anArray 
	midnightVertices := anArray! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightWatchhand: aWatchHand 
	midnightWatchhand := aWatchHand! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
step
	self isMovingWatchhand
		ifFalse: [^ self].
	midnightWatchhand
		ifNil: [^ self].
	vertices := midnightWatchhand vertices.
	self setRotationCenterFrom: owner center.
	self
		rotationDegreesFromMidnightPosition: (self class inDegrees: DateAndTime now)! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
stepTime
	^ 1000! !

Object subclass: #Dial05Interface
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!Dial05Interface methodsFor: 'initialize-release' stamp: 'pv 12/5/2013 20:09'!
delete
	proxy delete! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 20:12'!
doOneCycleNow
	proxy owner world doOneCycleNow! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 20:18'!
getWatchhand
	^ proxy ifGetWatchhand rotationDegreesFromMidnightPosition! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:55'!
setIfProxy: anAnalogClock 
	proxy := anAnalogClock! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:54'!
setWatchhand: anAngleInDegrees
	^ proxy ifGetWatchhand rotationDegreesFromMidnightPosition: anAngleInDegrees! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:52'!
startStepping
	^ proxy ifGetWatchhand startStepping! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:52'!
stopStepping
	^ proxy ifGetWatchhand stopStepping! !

CircleMorph subclass: #Dial05
	instanceVariableNames: 'boundsLag watchHand interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!Dial05 commentStamp: 'pv 12/2/2013 22:32' prior: 0!
* AnalogClock
This is the project manual for the AnalogClock tutorial.
You can fetch the sources from [http://ss3.gemstone.com/ss/AnalogClock SqueakSource-AnalogClock]
* Requirements
** Functional
*** Show an analog clock in Squeak
Show an analog clock with hour and minute watchhand.
:PROPERTIES:
:CUSTOM_ID: REQ101
:END:
*** Show a rotating watchhand
Show a PolygonMorph which rotates.
:PROPERTIES:
:CUSTOM_ID: REQ106
:END:
*** Show a rotating watchhand on a dial
Show a PolygonMorph which rotates on a dial formed like a circle.
:PROPERTIES:
:CUSTOM_ID: REQ107
:END:
*** Show a static watchhand on a dial able to get resized
Show a PolygonMorph on a dial which adapts when the dial gets resized.
:PROPERTIES:
:CUSTOM_ID: REQ108
:END:
*** Show a rotating watchhand on a dial able to get resized
Show a PolygonMorph rotating on a dial which adapts when the dial gets resized.
:PROPERTIES:
:CUSTOM_ID: REQ109
:END:
*** Synchronize clock to the OS time
The time shown on the AnalogClock is the same as the time of the OS we are running on.
:PROPERTIES:
:CUSTOM_ID: REQ102
:END:
*** Respond to the Pick up-Halo
The AnalogClock may be moved around. All its submorphs are included in an adequate manner.
:PROPERTIES:
:CUSTOM_ID: REQ103
:END:
*** Respond to the Resize-Halo
The AnalogClock may get resized. All its submorphs are included in an adequate manner.
:PROPERTIES:
:CUSTOM_ID: REQ104
:END:
*** Be able to embed one AnalogClock in another
The AnalogClock may get embedded into another one.
:PROPERTIES:
:CUSTOM_ID: REQ105
:END:
** Non-Functional
*** Show an analog clock in Squeak
Show information about the application lifecycle in the class comment. Use org-mode-format.
:PROPERTIES:
:CUSTOM_ID: REQ110
:END:
** Process 
** Tools
* Architecture and Design
** abc
*** Design Decision: Avoid doing everything in drawOn:
[http://www.squeaksource.com/WatchMorph WatchMorph] relies on drawOn:. With each time step and on each pich up- or resize-operation the whole watch is drawn.
This seems ok for a simple watch. But it is not scalable.
Decision <2013-11-24 Sun>: adapt Morphic's Layout-mechanism (TableLayout).
Traces to: [[#REQ108]]
:PROPERTIES:
:CUSTOM_ID: DES001
:END:
*** Design Decision: Hide implementation details of two watchhands for resize-operation
We use two watchhands to implement correct resize behaviour. The interface for a Dial should get concentrated in one class.
Decision <2013-12-02 Mon>: create ResizableWatchhand.
Traces to: [[#REQ109]]
:PROPERTIES:
:CUSTOM_ID: DES002
:END:
* Implementation
** Step 1
*** PVpub-AnalogClockPrototype01 (WatchHand01)
Shows a rotating PolygonMorph.
:PROPERTIES:
:CUSTOM_ID: IMP001
:END:
** Step 2
*** PVpub-AnalogClockPrototype02 (Dial02, WatchHand02)
Shows a rotating watchhand (PolygonMorph) rotating on a dial (CircleMorph). When resizing the clock, the watchhand does not adapt.
:PROPERTIES:
:CUSTOM_ID: IMP002
:END:
** Step 3
*** PVpub-AnalogClockPrototype03 (Dial03, WatchHand03)
Shows a non-rotating watchhand (PolygonMorph) on a dial (CircleMorph). When resizing the clock, the watchhand does adapt.
:PROPERTIES:
:CUSTOM_ID: IMP003
:END:
** Step 4
*** PVpub-AnalogClockPrototype04 (Dial04, WatchHand04)
Shows a rotating watchhand (PolygonMorph) on a dial (CircleMorph). When resizing the clock, the watchhand does adapt.
:PROPERTIES:
:CUSTOM_ID: IMP004
:END:
** Step 5
*** PVpub-AnalogClockPrototype05 (Dial05, ResizableWatchHand05)
Shows a rotating watchhand (PolygonMorph) on a dial (CircleMorph). When resizing the clock, the watchhand does adapt. The interplay between Dial and WatchHand is simplified. An analog clock may get embedded into another.
:PROPERTIES:
:CUSTOM_ID: IMP005
:END:
* Verification of Implementation
* Verification at Architecture Level
* Verification at Product Level
* Versions and Releases
** PVpub-AnalogClockPrototype01
*** VER001
abc
**** Implemented Requirements
[[#REQ106]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 3
:INSTANCE-LOC:                11
:CLASS-LOC:                   0
:MCZ:                         PVpub-AnalogClockPrototype01-pv.1
:END:
** PVpub-AnalogClockPrototype02
*** VER001
abc
**** Implemented Requirements
[[#REQ107]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 1
:SWA-Lint_InconsistentMethodClassification: 1
:INSTANCE-LOC:                35
:CLASS-LOC:                   0
:MCZ:                         PVpub-AnalogClockPrototype02-pv.1
:END:
** PVpub-AnalogClockPrototype03
*** VER001
abc
**** Implemented Requirements
[[#REQ108]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 1
:SWA-Lint_InconsistentMethodClassification: 1
:INSTANCE-LOC:                32
:CLASS-LOC:                   0
:MCZ:                         PVpub-AnalogClockPrototype03-pv.1
:END:
** PVpub-AnalogClockPrototype04
*** VER001
abc
**** Implemented Requirements
[[#REQ109]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 2
:SWA-Lint_InconsistentMethodClassification: 2
:INSTANCE-LOC:                84
:CLASS-LOC:                   6
:MCZ:                         PVpub-AnalogClockPrototype04-pv.1
:END:
** PVpub-AnalogClockPrototype05
*** VER001
abc
**** Implemented Requirements
[[#REQ109]]
**** Implemented Design Decision
[[#DES002]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 3
:SWA-Lint_InconsistentMethodClassification: 2
:INSTANCE-LOC:                108
:CLASS-LOC:                   6
:MCZ:                         PVpub-AnalogClockPrototype05-pv.1
:END:
*** VER002
Add class comment (org-mode)
**** Implemented Requirements
[[#REQ110]]
**** Metrics
:PROPERTIES:
:SWA-LINT_ClassNotReferenced: 3
:SWA-Lint_InconsistentMethodClassification: 2
:INSTANCE-LOC:                108
:CLASS-LOC:                   6
:MCZ:                         PVpub-AnalogClockPrototype05-pv.2
:END:
* Bugs
No bugs so far.
* Appendix
** Code snippets
*** Compute INSTANCE-LOC
*** Compute CLASS-LOC

!

!Dial05 methodsFor: 'drawing' stamp: 'pv 12/2/2013 20:26'!
drawOn: aCanvas 
	| currentExtent oldExtent |
	currentExtent := self bounds corner - self bounds origin.
	oldExtent := boundsLag corner - boundsLag origin.
	currentExtent ~= oldExtent
		ifTrue: [self submorphs
				do: [:each | each isMovingWatchhand
						ifTrue: [each step]].
			boundsLag := self bounds].
	super drawOn: aCanvas! !

!Dial05 methodsFor: 'test-interface' stamp: 'pv 12/5/2013 19:58'!
getIf
	^interface! !

!Dial05 methodsFor: 'test-interface' stamp: 'pv 12/4/2013 23:19'!
ifGetWatchhand
	"intended for use by the interface only"
	^ watchHand getMovingWatchhand! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/4/2013 22:45'!
initialize
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		 layoutPolicy: ConcentricLayout new.
	boundsLag := 1 @ 1 corner: 2 @ 2.
	self pvtInitializeResizableWatchhand;
		pvtInitializeInterface! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/5/2013 19:55'!
pvtInitializeInterface
	"let the analog clock (Dial05) get steered by Dial05Interface"
	interface := Dial05Interface new.
	interface setIfProxy: self! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/4/2013 22:48'!
pvtInitializeResizableWatchhand
	watchHand := ResizableWatchHand05 newFrom: self.
	watchHand
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9! !
